import{s as te,n as ae,o as ne}from"../chunks/scheduler.9039eef2.js";import{S as ie,i as re,g as l,s as i,r as O,A as le,h as o,f as a,c as r,j as Z,x as v,u as I,k as j,l as ee,y as oe,a as n,v as U,d as B,t as z,w as G}from"../chunks/index.ded8f90d.js";import{H as V,g as se}from"../chunks/Heading.79762d73.js";function me(q){let s,x,T,y,m,N='<img src="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/images/trl_banner_dark.png"/>',$,u,P,p,W=`TRL is a full stack library where we provide a set of tools to train transformer language models with Reinforcement Learning, from the Supervised Fine-tuning step (SFT), Reward Modeling step (RM) to the Proximal Policy Optimization (PPO) step.
The library is integrated with 🤗 <a href="https://github.com/huggingface/transformers" rel="nofollow">transformers</a>.`,M,g,J='<img src="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/images/TRL-readme.png"/>',k,f,K="Check the appropriate sections of the documentation depending on your needs:",H,c,R,h,Q='<li><a href="models">Model Classes</a>: <em>A brief overview of what each public model class does.</em></li> <li><a href="sft_trainer"><code>SFTTrainer</code></a>: <em>Supervise Fine-tune your model easily with <code>SFTTrainer</code></em></li> <li><a href="reward_trainer"><code>RewardTrainer</code></a>: <em>Train easily your reward model using <code>RewardTrainer</code>.</em></li> <li><a href="ppo_trainer"><code>PPOTrainer</code></a>: <em>Further fine-tune the supervised fine-tuned model using PPO algorithm</em></li> <li><a href="best-of-n">Best-of-N Sampling</a>: <em>Use best of n sampling as an alternative way to sample predictions from your active model</em></li> <li><a href="dpo_trainer"><code>DPOTrainer</code></a>: <em>Direct Preference Optimization training using <code>DPOTrainer</code>.</em></li> <li><a href="text_environment"><code>TextEnvironment</code></a>: <em>Text environment to train your model using tools with RL.</em></li>',F,b,S,w,X='<li><a href="sentiment_tuning">Sentiment Tuning</a>: <em>Fine tune your model to generate positive movie contents</em></li> <li><a href="lora_tuning_peft">Training with PEFT</a>: <em>Memory efficient RLHF training using adapters with PEFT</em></li> <li><a href="detoxifying_a_lm">Detoxifying LLMs</a>: <em>Detoxify your language model through RLHF</em></li> <li><a href="using_llama_models">StackLlama</a>: <em>End-to-end RLHF training of a Llama model on Stack exchange dataset</em></li> <li><a href="learning_tools">Learning with Tools</a>: <em>Walkthrough of using <code>TextEnvironments</code></em></li> <li><a href="multi_adapter_rl">Multi-Adapter Training</a>: <em>Use a single base model and multiple adapters for memory efficient end-to-end training</em></li>',D,_,C,d,Y='<div class="w-full flex flex-col space-y-4 md:space-y-0 md:grid md:grid-cols-2 md:gap-y-4 md:gap-x-5"><a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/rlhf"><img src="https://raw.githubusercontent.com/huggingface/blog/main/assets/120_rlhf/thumbnail.png" alt="thumbnail"/> <p class="text-gray-700">Illustrating Reinforcement Learning from Human Feedback</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/trl-peft"><img src="https://github.com/huggingface/blog/blob/main/assets/133_trl_peft/thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">Fine-tuning 20B LLMs with RLHF on a 24GB consumer GPU</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/stackllama"><img src="https://github.com/huggingface/blog/blob/main/assets/138_stackllama/thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">StackLLaMA: A hands-on guide to train LLaMA with RLHF</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/dpo-trl"><img src="https://github.com/huggingface/blog/blob/main/assets/157_dpo_trl/dpo_thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">Fine-tune Llama 2 with DPO</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/trl-ddpo"><img src="https://github.com/huggingface/blog/blob/main/assets/166_trl_ddpo/thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">Finetune Stable Diffusion Models with DDPO via TRL</p></a></div>',E,L,A;return u=new V({props:{title:"TRL - Transformer Reinforcement Learning",local:"trl---transformer-reinforcement-learning",headingTag:"h1"}}),c=new V({props:{title:"API documentation",local:"api-documentation",headingTag:"h2"}}),b=new V({props:{title:"Examples",local:"examples",headingTag:"h2"}}),_=new V({props:{title:"Blog posts",local:"blog-posts",headingTag:"h2"}}),{c(){s=l("meta"),x=i(),T=l("p"),y=i(),m=l("div"),m.innerHTML=N,$=i(),O(u.$$.fragment),P=i(),p=l("p"),p.innerHTML=W,M=i(),g=l("div"),g.innerHTML=J,k=i(),f=l("p"),f.textContent=K,H=i(),O(c.$$.fragment),R=i(),h=l("ul"),h.innerHTML=Q,F=i(),O(b.$$.fragment),S=i(),w=l("ul"),w.innerHTML=X,D=i(),O(_.$$.fragment),C=i(),d=l("div"),d.innerHTML=Y,E=i(),L=l("p"),this.h()},l(e){const t=le("svelte-u9bgzb",document.head);s=o(t,"META",{name:!0,content:!0}),t.forEach(a),x=r(e),T=o(e,"P",{}),Z(T).forEach(a),y=r(e),m=o(e,"DIV",{style:!0,"data-svelte-h":!0}),v(m)!=="svelte-160pg0b"&&(m.innerHTML=N),$=r(e),I(u.$$.fragment,e),P=r(e),p=o(e,"P",{"data-svelte-h":!0}),v(p)!=="svelte-k9dkk3"&&(p.innerHTML=W),M=r(e),g=o(e,"DIV",{style:!0,"data-svelte-h":!0}),v(g)!=="svelte-dcmq8o"&&(g.innerHTML=J),k=r(e),f=o(e,"P",{"data-svelte-h":!0}),v(f)!=="svelte-113r82x"&&(f.textContent=K),H=r(e),I(c.$$.fragment,e),R=r(e),h=o(e,"UL",{"data-svelte-h":!0}),v(h)!=="svelte-wrckpz"&&(h.innerHTML=Q),F=r(e),I(b.$$.fragment,e),S=r(e),w=o(e,"UL",{"data-svelte-h":!0}),v(w)!=="svelte-a8fpa6"&&(w.innerHTML=X),D=r(e),I(_.$$.fragment,e),C=r(e),d=o(e,"DIV",{class:!0,"data-svelte-h":!0}),v(d)!=="svelte-8ufs3j"&&(d.innerHTML=Y),E=r(e),L=o(e,"P",{}),Z(L).forEach(a),this.h()},h(){j(s,"name","hf:doc:metadata"),j(s,"content",ge),ee(m,"text-align","center"),ee(g,"text-align","center"),j(d,"class","mt-10")},m(e,t){oe(document.head,s),n(e,x,t),n(e,T,t),n(e,y,t),n(e,m,t),n(e,$,t),U(u,e,t),n(e,P,t),n(e,p,t),n(e,M,t),n(e,g,t),n(e,k,t),n(e,f,t),n(e,H,t),U(c,e,t),n(e,R,t),n(e,h,t),n(e,F,t),U(b,e,t),n(e,S,t),n(e,w,t),n(e,D,t),U(_,e,t),n(e,C,t),n(e,d,t),n(e,E,t),n(e,L,t),A=!0},p:ae,i(e){A||(B(u.$$.fragment,e),B(c.$$.fragment,e),B(b.$$.fragment,e),B(_.$$.fragment,e),A=!0)},o(e){z(u.$$.fragment,e),z(c.$$.fragment,e),z(b.$$.fragment,e),z(_.$$.fragment,e),A=!1},d(e){e&&(a(x),a(T),a(y),a(m),a($),a(P),a(p),a(M),a(g),a(k),a(f),a(H),a(R),a(h),a(F),a(S),a(w),a(D),a(C),a(d),a(E),a(L)),a(s),G(u,e),G(c,e),G(b,e),G(_,e)}}}const ge='{"title":"TRL - Transformer Reinforcement Learning","local":"trl---transformer-reinforcement-learning","sections":[{"title":"API documentation","local":"api-documentation","sections":[],"depth":2},{"title":"Examples","local":"examples","sections":[],"depth":2},{"title":"Blog posts","local":"blog-posts","sections":[],"depth":2}],"depth":1}';function de(q){return ne(()=>{new URLSearchParams(window.location.search).get("fw"),window.hfDocGoto=se}),[]}class ce extends ie{constructor(s){super(),re(this,s,de,me,te,{})}}export{ce as component};
